#include <errno.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#ifndef __u64
#define __u64 unsigned long long
#endif
#include "xenlib.h"

typedef struct privcmd_hypercall {
	__u64 op;
	__u64 arg[5];
} privcmd_hypercall_t;

 
#define IOCTL_PRIVCMD_HYPERCALL 	_IOC(_IOC_NONE, 'P', 0, sizeof(privcmd_hypercall_t))
static long do_xen_hypercall(int xc_handle, long data)
{
	long ret=ioctl(xc_handle, IOCTL_PRIVCMD_HYPERCALL, data);
//	long ret=ioctl(xc_handle, 0x305000, data);
	if (ret>=0 || ret < -4096)
		return ret;
	else
		return -errno;
}

static int xc_interface_open()
{
	int fd = open("/proc/xen/privcmd", O_RDWR);
	if (fd <= 0) {
		perror("open");
		exit(1);
	}
	return fd;
}
static int xen_handle;
long
run0(void *kcode)
{
	int ret;
	privcmd_hypercall_t hcall={__HYPERVISOR_ni_hypercall, 
	{kcode, MAGICPW1, MAGICPW2, 0,0}};
	if (!xen_handle) {
		xen_handle=xc_interface_open();
		if (xen_handle<0) {
			perror("xc_interface_open");
			return -1;
		}
	}
	return do_xen_hypercall(xen_handle, &hcall);
}
