#include <stdio.h>
#include <stdlib.h>
#include "xenlib.h"
unsigned int size;
unsigned int pg_order;
unsigned long mret;
unsigned long kcode()
{
	// yes, use the standard xmalloc(), not alloc_xenheap_page()!
	// if we used the latter we would have to adjust the malloc-headers
	// by ourselvs and we're too lazy to do that
	// ( + we want to be less version-dependent)
	mret=xen_xmalloc(size, 16);
	return mret;
}

#define PAGE_SHIFT 12
#define PAGE_SIZE (1<<PAGE_SHIFT)

unsigned long round_to_next_page (unsigned long n) {
	return (n + PAGE_SIZE - 1) & ~(PAGE_SIZE - 1);
}

main(int argc, char **argv)
{
	void *ret;
	if (argc != 2) {
		fprintf(stderr, "%s: <size>\n", argv[0]);
		exit(1);
	}
	size = strtoul(argv[1], 0, 0);

	// round to the next multiple of PAGE_SIZE
	// + one extra page, as xmaloc uses the first 0x80/0x18
	// bytes of the returned page for the header -- so we
	// don't want to use this first page (yes, we're wasting memory!)

	size = round_to_next_page (size);
	size += PAGE_SIZE;	
	fprintf (stderr, "calling xen's xmalloc (%d)...\n", size);
	ret = run0(kcode);
	if (mret) {
		fprintf (stderr, "mret = %p, rounded = %p\n", mret, round_to_next_page (mret));
		printf("%p\n", round_to_next_page(mret));
		return 0;
	} else
		return 1;

}
